#include "avrx.h"
#include "avrx-io.h"
#include "hardware.h"
#include "LcdTask.h"
#include "LedTask.h"
#include "MotorTask.h"
#include "mob_eeprom.h"

unsigned char LedPattern[] = {  0xF0,     // LED_FLASHSLOW
                                0xAA,     // LED_FLASHFAST
                                0xFE,     // LED_WINK
                                0x01,     // LED_BLINK
                                0xA0 };   // LED_DOUBLE

TimerControlBlock LedTimer;

AVRX_GCC_TASKDEF(LedTask, 14, 1)
{
    unsigned char LedBit = 0x00;
    unsigned char LedMode = 0;
    
    while(1)
    {
        AvrXDelay(&LedTimer, MILLISECOND(125));

        LedBit = (LedBit<<1);
        if (LedBit == 0)
        {
            // Decode state of the MOB and set the LED flash mode
            // appropriately.

            LedMode = LED_FLASHSLOW;        // Normal
            
            if (!RC0.valid && !RC1.valid && !RC2.valid)
                LedMode = LED_WINK;         // No R/C Signal
            if (fDisable.lcd_disable)
            {
                if (LedMode == LED_WINK)
                    LedMode = LED_DOUBLE;   // Output disabled, no signal
                else
                    LedMode = LED_BLINK;    // Output disabled
            }
            if (EEpromResetFlag)
                LedMode = LED_FLASHFAST;    // Corrupt EEPROM
                
            LedBit = 0x01;
        }
        if (LedPattern[(unsigned char)LedMode] & LedBit)
        {
            LED2_ON();
        }
        else
        {
            LED2_OFF();
        }
    }
}
